<script lang="ts">
import Vue from 'vue';

import { DibGradientNumber, DibLineGraph } from './index.vue';
import dibStatBubbles from './dib-stat-bubbles.vue';
export default Vue.extend({
  name: 'DibByTheNumbers',
  components: {
    DibGradientNumber,
    DibLineGraph,
    dibStatBubbles,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <section class="slp-my-96 numbers-block">
    <SlpContainer>
      <div class="slp-mb-64 numbers-block__header">
        <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-24">
          {{ data.header }}
        </SlpTypography>
        <SlpTypography tag="div" variant="heading5">
          <div v-html="$md.render(data.body)" />
        </SlpTypography>
        <SlpTypography tag="p" variant="body3" class="disclaimer">
          {{ data.asterisk }}
        </SlpTypography>
      </div>

      <!-- Gender URG -->
      <article>
        <SlpTypography tag="h3" variant="heading3-bold" class="slp-mb-48">
          {{ data.gender_urg.header }}
        </SlpTypography>
        <SlpTypography
          tag="h4"
          variant="heading5-bold"
          class="slp-my-24 numbers-block__subheader"
        >
          {{ data.gender_urg.label }}
        </SlpTypography>
        <div class="circle-wrapper">
          <div
            v-for="item in data.gender_urg.breakdown"
            :key="item.text"
            class="circle"
          >
            <div class="item">
              <DibGradientNumber :number="item.number" :font-size="80" />
            </div>

            <div class="text">
              <SlpTypography variant="heading5-bold" tag="div">
                <span v-html="$md.render(item.text)"></span>
              </SlpTypography>
            </div>
          </div>
        </div>
        <div class="featured-stats">
          <div
            v-for="item in data.gender_urg.featured_stats"
            :key="item.text"
            class="stat"
          >
            <DibGradientNumber
              :key="item.text"
              :number="item.number"
              :font-size="80"
            />
            <div class="label">
              <SlpTypography variant="heading5-bold" tag="div">
                {{ item.label }}
              </SlpTypography>
            </div>
            <div class="text slp-mt-24">
              <SlpTypography variant="body3" tag="div">
                {{ item.text }}
              </SlpTypography>
            </div>
          </div>
        </div>
      </article>

      <!-- Ethnic URG -->
      <article class="ethnic-urg">
        <SlpTypography tag="h3" variant="heading3-bold" class="slp-mb-48">
          {{ data.ethnic_urg.header }}
        </SlpTypography>
        <SlpTypography
          tag="h4"
          variant="heading5-bold"
          class="slp-my-24 numbers-block__subheader"
        >
          {{ data.ethnic_urg.label }}
        </SlpTypography>
        <dibStatBubbles :data="data.ethnic_urg.breakdown" />

        <div class="featured-stats">
          <div
            v-for="item in data.ethnic_urg.featured_stats"
            :key="item.text"
            class="stat"
          >
            <DibGradientNumber
              :key="item.text"
              :number="item.number"
              :font-size="80"
            />
            <div class="label">
              <SlpTypography variant="heading5-bold" tag="div">
                {{ item.label }}
              </SlpTypography>
            </div>
            <div class="text slp-mt-24">
              <SlpTypography variant="body3" tag="div">
                {{ item.text }}
              </SlpTypography>
            </div>
          </div>
        </div>
      </article>

      <!-- Location -->
      <article class="location">
        <SlpTypography tag="h3" variant="heading3-bold" class="slp-mb-48">
          {{ data.location.header }}
        </SlpTypography>
        <SlpTypography
          tag="h4"
          variant="heading5-bold"
          class="slp-my-24 numbers-block__subheader"
        >
        </SlpTypography>
        <DibLineGraph :data="data.location.graph" />
        <div class="featured-stats">
          <div
            v-for="item in data.location.featured_stats"
            :key="item.text"
            class="stat"
          >
            <DibGradientNumber
              :key="item.text"
              :number="item.number"
              :font-size="80"
            />
            <div class="label">
              <SlpTypography variant="heading5-bold" tag="div">
                {{ item.label }}
              </SlpTypography>
            </div>
            <div class="text">
              <SlpTypography variant="heading5-bold" tag="div">
                {{ item.text }}
              </SlpTypography>
            </div>
          </div>
        </div>
        <SlpTypography class="disclaimer" tag="div" variant="body3">
          <span v-html="$md.render(data.disclaimer_text)" />
        </SlpTypography>
      </article>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.numbers-block {
  &__header {
    width: 80%;

    &:deep {
      a {
        text-decoration: underline;
        color: $color-text-300;

        &:hover {
          color: $color-text-link-100;
        }
      }
    }

    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }

  &__subheader {
    text-align: center;
  }

  .circle-wrapper {
    display: flex;
    padding: 0 72px;
    margin: 48px 0 96px 0;
    justify-content: space-between;
    align-items: flex-start;
    position: relative;

    @media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
      padding: 0;
      justify-content: space-between;
      gap: 24px;
      flex-wrap: wrap;
    }

    @media (max-width: $breakpoint-md) {
      flex-wrap: wrap;
      justify-content: center;
    }

    .circle {
      position: relative;

      @media (max-width: $breakpoint-md) {
        margin-bottom: 32px;
      }

      &:nth-of-type(3),
      &:nth-of-type(4) {
        .gradient-number {
          left: 24%;
        }
      }
    }

    .text {
      text-align: center;
      margin-top: 24px;
    }

    .item {
      width: 200px;
      height: 200px;
      position: relative;
      border-radius: 50%;
      background: transparent;

      &:after {
        background: linear-gradient(
            93.78deg,
            rgba(227, 153, 93, 0.7) 8.53%,
            rgba(203, 146, 150, 0.7) 14.9%,
            rgba(127, 72, 214, 0.7) 95.91%
          )
          border-box;
        border: 1.5px solid transparent;
        width: 100%;
        height: 100%;
        border-radius: 50%;
        bottom: 0;
        content: '';
        left: 0;
        -webkit-mask:
          linear-gradient(#fff, #fff 0) padding-box,
          linear-gradient(#fff, #fff 0);
        -webkit-mask:
          linear-gradient(#fff 0 0) padding-box,
          linear-gradient(#fff 0 0);
        -webkit-mask-composite: xor;
        mask-composite: exclude;
        position: absolute;
        right: 0;
        top: 0;
        z-index: 0;
      }
    }

    .gradient-number {
      left: 10%;
      position: absolute;
      top: 8%;
      z-index: 1;
    }
  }

  .featured-stats {
    padding: 0 72px;
    display: flex;
    justify-content: space-between;
    align-items: flex-start;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
      padding: 0;
    }

    .stat {
      @media (max-width: $breakpoint-md) {
        margin-bottom: 48px;
      }
      .gradient-number {
        margin-bottom: 32px;
      }
      .text {
        color: $color-text-200;
      }

      .text {
        max-width: 300px;

        @media (max-width: $breakpoint-md) {
          max-width: 100%;
        }
      }
    }
  }

  .ethnic-urg {
    margin-top: 96px;

    .featured-stats {
      margin-top: 164px;
      display: flex;
      justify-content: space-between;
      align-items: flex-start;
      @media (max-width: $breakpoint-md) {
        margin-top: 264px;
      }
      .stat {
        @media (max-width: $breakpoint-md) {
          margin-bottom: 48px;
        }
        .gradient-number {
          margin-bottom: 32px;
        }
        .text {
          color: $color-text-200;
        }

        .text {
          max-width: 300px;

          @media (max-width: $breakpoint-md) {
            max-width: 100%;
          }
        }
      }
    }
  }

  .location {
    padding-top: 48px;
    .graph-wrapper {
      margin-bottom: 96px;
    }
  }

  .disclaimer {
    margin-top: 96px;
    color: $color-text-200;

    &:deep p {
      margin-bottom: 16px;
    }
  }
}
</style>
